import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import security from "./security";
import './index.scss';

var CNHighlight = /*#__PURE__*/function (_Component) {
  _inheritsLoose(CNHighlight, _Component);

  function CNHighlight(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    _this.state = {
      content: _this.props.content
    };
    return _this;
  }

  var _proto = CNHighlight.prototype;

  _proto.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    // 只有content会接收变化
    if (nextProps.content !== this.props.content) {
      this.setState({
        content: nextProps.content
      });
    }
  };

  _proto.createContent = function createContent(html) {
    security.initUtil();
    return {
      __html: security.escapeHtml(html)
    };
  };

  _proto.render = function render() {
    var _this$props = this.props,
        className = _this$props.className,
        style = _this$props.style,
        font = _this$props.font,
        space = _this$props.space,
        children = _this$props.children;
    var content = this.state.content;
    var mixin = style || {};

    if (font) {
      mixin.fontSize = font + 'px';
    }

    if (space) {
      mixin.wordBreak = 'break-word';
      mixin.whiteSpace = 'pre-wrap';
    }

    return children ? /*#__PURE__*/React.createElement("div", {
      className: "cn-highlight " + (className ? className : ''),
      style: mixin
    }, children) : /*#__PURE__*/React.createElement("div", {
      className: "cn-highlight " + (className ? className : ''),
      style: mixin,
      dangerouslySetInnerHTML: this.createContent(content)
    });
  };

  return CNHighlight;
}(Component);

CNHighlight.propTypes = {
  className: PropTypes.string,
  style: PropTypes.object,
  font: PropTypes.number,
  space: PropTypes.bool
};
CNHighlight.defaultProps = {
  space: false
};
export default CNHighlight;
export { security };