"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _security = _interopRequireDefault(require("./security"));

exports.security = _security["default"];

require("./index.scss");

var CNHighlight = /*#__PURE__*/function (_Component) {
  (0, _inheritsLoose2["default"])(CNHighlight, _Component);

  function CNHighlight(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    _this.state = {
      content: _this.props.content
    };
    return _this;
  }

  var _proto = CNHighlight.prototype;

  _proto.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    // 只有content会接收变化
    if (nextProps.content !== this.props.content) {
      this.setState({
        content: nextProps.content
      });
    }
  };

  _proto.createContent = function createContent(html) {
    _security["default"].initUtil();

    return {
      __html: _security["default"].escapeHtml(html)
    };
  };

  _proto.render = function render() {
    var _this$props = this.props,
        className = _this$props.className,
        style = _this$props.style,
        font = _this$props.font,
        space = _this$props.space,
        children = _this$props.children;
    var content = this.state.content;
    var mixin = style || {};

    if (font) {
      mixin.fontSize = font + 'px';
    }

    if (space) {
      mixin.wordBreak = 'break-word';
      mixin.whiteSpace = 'pre-wrap';
    }

    return children ? /*#__PURE__*/_react["default"].createElement("div", {
      className: "cn-highlight " + (className ? className : ''),
      style: mixin
    }, children) : /*#__PURE__*/_react["default"].createElement("div", {
      className: "cn-highlight " + (className ? className : ''),
      style: mixin,
      dangerouslySetInnerHTML: this.createContent(content)
    });
  };

  return CNHighlight;
}(_react.Component);

CNHighlight.propTypes = {
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  font: _propTypes["default"].number,
  space: _propTypes["default"].bool
};
CNHighlight.defaultProps = {
  space: false
};
var _default = CNHighlight;
exports["default"] = _default;